//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DimGray
#property indicator_color3  PaleVioletRed
#property indicator_color4  DeepSkyBlue
#property indicator_color5  DimGray
#property indicator_color6  PaleVioletRed
#property indicator_color7  Silver
#property indicator_color8  Silver
#property indicator_style2  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_style8  STYLE_DOT
#property indicator_width7  2

//
//
//
//
//

extern int BandsPeriod      = 3;
extern int BandsPrice       = 8;
extern int DeviationsPeriod = 7;
extern int FutureBars       = 100;

//
//
//
//
//

double bandup[];
double banddn[];
double bandmi[];
double banfup[];
double banfdn[];
double banfmi[];
double lrvalue[];
double lrforecast[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,bandup);
   SetIndexBuffer(1,bandmi);
   SetIndexBuffer(2,banddn);
   SetIndexBuffer(3,banfup);
   SetIndexBuffer(4,banfmi);
   SetIndexBuffer(5,banfdn);
   SetIndexBuffer(6,lrvalue);
   SetIndexBuffer(7,lrforecast);
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) 
   {
       double linreg    = iLinr(getPrice(BandsPrice,i),BandsPeriod,i);
       double deviation = iDeviation(linreg,DeviationsPeriod,i);
         lrvalue[i] = linreg;
         if (i>Bars-1)
         {
            bandup[i] = linreg;
            banddn[i] = linreg;
            bandmi[i] = linreg;
            continue;
         }         
         
         //
         //
         //
         //
         //
         
         bandup[i] = bandup[i+1];
         bandmi[i] = bandmi[i+1];
         banddn[i] = banddn[i+1];
         if (linreg>bandup[i+1] || linreg<banddn[i+1])
         {
            bandup[i] = linreg+2.0*deviation;
            banddn[i] = linreg-2.0*deviation;
            bandmi[i] = linreg;
         }
         
         //
         //
         //
         //
         //
         
         if (i==0)
         {
            double slope = linreg-iLinr(getPrice(BandsPrice,i+1),BandsPeriod,i+1);
               for (int cross=0; cross<FutureBars; cross++)
               {
                  double value = linreg+slope*cross;
                     if (value > bandup[0]) break;
                     if (value < banddn[0]) break;
               }
               for (int k=0; k<=cross; k++)
               {
                  banfup[cross-k]     = bandup[0];
                  banfdn[cross-k]     = banddn[0];
                  banfmi[cross-k]     = bandmi[0];
                  lrforecast[cross-k] = linreg+slope*k;
               }                  
         }
   }
   
   SetIndexShift(3,cross); SetIndexDrawBegin(3,Bars-cross-1);
   SetIndexShift(4,cross); SetIndexDrawBegin(4,Bars-cross-1);
   SetIndexShift(5,cross); SetIndexDrawBegin(5,Bars-cross-1);
   SetIndexShift(7,cross); SetIndexDrawBegin(7,Bars-cross-1);
   return(0);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7 : return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      case 8 : return((Open[i]+High[i]+Low[i]+Close[i]+Close[i])/5.0);
      default : return(iMA(NULL,0,1,0,MODE_SMA,MathMax(MathMin(type,6),0),i));
   }
}

//
//
//
//
//

double workDev[];
double iDeviation(double value, double period, int r, bool isSample=false)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars); r = Bars-r-1;

   workDev[r] = value; if (r<period) return(0);   
   
   //
   //
   //
   //
   //
   
   double avg = 0; for (int k=0; k<period; k++) avg += workDev[r-k]; avg /= period;
   double sum = 0; for (    k=0; k<period; k++) sum += MathPow((workDev[r-k]-avg),2);
   if (isSample)
         return(MathSqrt(sum/(period-1.0)));
   else  return(MathSqrt(sum/period));
}

//
//
//
//
//

double workLinr[];
double iLinr(double price, double period, int r)
{
   if (ArrayRange(workLinr,0)!= Bars) ArrayResize(workLinr,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
   
      period = MathMax(period,1);
      workLinr[r] = price;
         if (r<period) return(price);
         double lwmw = period; double lwma = lwmw*price;
         double sma  = price;
         for(int k=1; k<period && (r-k)>=0; k++)
         {
            double weight = period-k;
                   lwmw  += weight;
                   lwma  += weight*workLinr[r-k];  
                   sma   +=        workLinr[r-k];
         }             
   
   return(3.0*lwma/lwmw-2.0*sma/period);
}